#!/bin/sh

bc <<EOF
define choose(n, k) {
  if ( k == 0 ) return(1)
  if ( n <= 0 ) return(0)
  return(choose(n-1, k-1) * n / k)
}
define mannwhitney(n, m, u) {
  auto d, total
  if ( u < 0 ) return(0)
  if ( m == 0 ) return(1)
  total=0
  for( d=0 ; d<= n-m ; d= d+1 ) total= total+mannwhitney(n-d-1, m-1, u-m*d)
  return(total)
}
define mannwhitney_i(n, m, u) {
  auto dind, d[], total
  if ( n < m || u < 0 ) return(0)
  total= 0
  dind= 0
  d[0]= 0
  while ( dind >= 0 ) {
    while ( m > 1 ) {
      dind += 1
      d[dind]= 0
      n -= 1
      m -= 1
    }
    total += 1
    while ( dind >= 0 ) {
      d[dind] += 1
      n -= 1
      u -= m
      if ( n >= m && u >= 0 ) break
      n += d[dind] + 1
      u += m * d[dind]
      m += 1
      dind -= 1
    }
  }
  return(total)
}
choose(2*$1, $1)
mannwhitney(2*$1, $1, $2)
EOF

