module Main where

import System.Environment

main = do
  [sizestr, ustr] <- getArgs
  let [size, u] = map read [sizestr, ustr]
  print (choose (2 * size) size)
  print (nlimitchoices (2*size) size u)


-- Binomial coefficient: number of choices of m out of n
choose :: Int -> Int -> Int
choose _ 0 = 1
choose 0 _ = 0
choose n m = (choose (n-1) (m-1)) * n `div` m


-- The number of choices m out of n with at most the given Mann-Whitney U.
nlimitchoices :: Int -> Int -> Int -> Integer
nlimitchoices n m u
  | u < 0 = 0
  | m == 0 = 1
  | otherwise = sum [ nlimitchoices (n-d-1) (m-1) (u-m*d) | d <- [0..(n-m)] ]

