#!/usr/bin/pugs

use v6;
# use Memoize;

@*ARGS.elems == 2 or die "usage: perl6_mannwhitney.p6 <size of both samples> <U>";

my Int ($size, $Ugiven)= @*ARGS;

my Int sub choose( Int $n, Int $k )
{
  return 1 if $k == 0;
  return 0 if $n == 0;
  return choose($n-1, $k-1) * $n / $k;
}

# compute integral of normal distribution with variance 1 from x to infinity
# according to Abramowitz and Stegun
my Num sub sig_as( Num $x )
{
  my Num @coeffs= ( 0.319381530, -0.356563782, 1.781477937, -1.821255978, 1.330274429 );
  my Num $PI= 3.1415926535897932384626433832795029;

  my Num $poly= 0;
  my Num $t= 1/(1+0.2316419*$x);
  my Num $tpow= $t;
  for (@coeffs) -> $coef {
    $poly += $coef * $tpow;
    $tpow *= $t;
  }
  return $poly * exp(-$x*$x/2) / sqrt(2*$PI);
}

my Int sub nlimitchoices( Int $n, Int $m, Int $u)
{
  return 0 if $u < 0;
  return 1 if $m == 0;
  my Int $sum= 0;
  map { $sum += nlimitchoices($n-$_-1, $m-1, $u-$_*$m); } (0..$n-$m);
  return $sum;
}

# memoize 'nlimitchoices';

my Int $nchoices= choose(2*$size, $size);

my Int $Usmaller= nlimitchoices(2*$size, $size, $Ugiven);

print "# of permutations (out of $nchoices) with smaller or equal Us: $Usmaller\n";

# print "probability of a smaller U (= one-tailed significance): ",
# 	$Usmaller / $nchoices, "\n";

# my Num $z= abs($Ugiven - $size*$size/2) / sqrt($size*$size*(2*$size+1)/12);
# print "significance according to Gaussian approximation: ", sig_as($z), "\n";

