#!/usr/bin/perl -w

use strict;
use bigint;
use Memoize;

$#ARGV == 1 or die "usage: perl_mannwhitney.pl <size of both samples> <U>";

my ($size, $Ugiven)= @ARGV;

sub choose
{
  my ($n, $k)= @_;

  return 1 if $k == 0;
  return 0 if $n == 0;
  return choose($n-1, $k-1) * $n / $k;
}

sub nlimitchoices
{
  my ($n, $m, $u)= @_;

  return 0 if $u < 0;
  return 1 if $m == 0;
  my $sum= 0;
  map { $sum += nlimitchoices($n-$_-1, $m-1, $u-$_*$m); } (0..$n-$m);
  return $sum;
}

my $x=1;

print ref($x), "\n";

# memoize 'nlimitchoices';

print choose(2*$size, $size), "\n";

print nlimitchoices(2*$size, $size, $Ugiven), "\n";

