#!/usr/bin/perl -w

use strict;
use Math::BigInt lib => "GMP";
use Memoize;

$#ARGV == 1 or die "usage: $0 <size of both samples> <U>";

my ($size, $Ugiven)= @ARGV;

sub choose
{
  my ($n, $k)= @_;

  return Math::BigInt->bone() if $k == 0;
  return Math::BigInt->bzero() if $n == 0;
  my $result= choose($n-1, $k-1);
  $result->bmul($n);
  $result->bdiv($k);
  return $result;
}

sub nlimitchoices
{
  my ($n, $m, $u)= @_;

  return Math::BigInt->bzero() if $u < 0;
  return Math::BigInt->bone() if $m == 0;
  my $sum= Math::BigInt->bzero();
  map { $sum->badd(nlimitchoices($n-$_-1, $m-1, $u-$_*$m)); } (0..$n-$m);
  return $sum;
}

memoize 'nlimitchoices';

print choose(2*$size, $size), "\n";

print nlimitchoices(2*$size, $size, $Ugiven), "\n";

