#!/usr/bin/perl -w

use strict;
use Math::BigInt lib => "GMP";

$#ARGV == 1 or die "usage: perl_mannwhitney_MBI_ref.pl <size of both samples> <U>";

my ($size, $Ugiven)= @ARGV;

sub choose
{
  my ($n, $k)= @_;

  return Math::BigInt->bone() if $k == 0;
  return Math::BigInt->bzero() if $n == 0;
  my $result= choose($n-1, $k-1);
  $result->bmul($n);
  $result->bdiv($k);
  return $result;
}

sub nlimitchoices
{
  my ($sum, $n, $m, $u)= @_;

  return if $u < 0;
  if( $m == 0 ) {
    $$sum->binc();
    return;
  }
  # important: use for loop here, not map (may actually create list and use
  # lots of RAM)
  for (0..$n-$m) { nlimitchoices($sum, $n-$_-1, $m-1, $u-$_*$m); }
}

print choose(2*$size, $size), "\n";

my $Usmaller= Math::BigInt->bzero();
nlimitchoices(\$Usmaller, 2*$size, $size, $Ugiven);

print $Usmaller->bstr(), "\n";


